# `⁙` diceware

[![Checks](https://img.shields.io/github/workflow/status/norskeld/diceware/check?style=flat-square&colorA=22272d&colorB=22272d&label=checks)](https://github.com/norskeld/diceware/actions)

Rust crate and CLI for generating strong [Diceware] passphrases.

## CLI usage

As of now you can install it globally via **cargo** (assuming you have cargo and rustc installed):

```shell
cargo install --git https://github.com/norskeld/diceware
```

Just invoke `diceware --help`. It's really simple.

```shell
diceware 0.1.1
Generates strong Diceware passphrases.

USAGE:
    diceware [OPTIONS]

OPTIONS:
    -l, --length <LENGTH>        How much words you want to generate [default: 6]
    -w, --wordlist <WORDLIST>    Path to a custom wordlist
    -e, --entropy                Show entropy of the passphrase
    -h, --help                   Print help information
    -V, --version                Print version information
```

## Example of output

```shell
$ diceware --entropy

probation overdraft debtor ground nintendo sculptor

Possibilities: 7776
Entropy: 77.55 bits

More about entropy at https://theworld.com/~reinhold/dicewarefaq.html#entropy
```

## Crate usage

You can use this crate as a git dependency:

```toml
[dependencies]
diceware = { git = "https://github.com/norskeld/diceware" }
```

## Notes

By default CLI uses the [EFF long wordlist][eff-long-wordlist], which is a little bit better than the one original one.

## Diceware

In short, passphrases are generated by "throwing" a dice five times, joining the numbers into one, and then looking up for the word with the corresponding number in the wordlist. This process repeats N times (default is **6**) until all words are found. You can find more information about that technique on [the official Diceware page][diceware-official] or on [the Diceware FAQ page][diceware-faq].

## Todo

- [ ] Tests.
- [ ] Homebrew [formula] for installing binary.

## License

[MIT](LICENSE).

<!-- Links. -->

[diceware]: https://en.wikipedia.org/wiki/Diceware
[eff-long-wordlist]: https://eff.org/deeplinks/2016/07/new-wordlists-random-passphrases
[formula]: https://docs.brew.sh/Formula-Cookbook
[eff-wordlist]: https://eff.org/deeplinks/2016/07/new-wordlists-random-passphrases
[diceware-official]: https://theworld.com/~reinhold/diceware.html
[diceware-faq]: https://theworld.com/~reinhold/dicewarefaq.html
